The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

Public Member Functions | List of all members
stk::JetTable Class Reference

STK jet table class. More...

`#include <JetTable.h>`

Inheritance diagram for stk::JetTable:

## Public Member Functions
StkFloat | tick (StkFloat input)
| Take one sample input and map to one sample of output.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Take a channel of the StkFrames object as inputs to the table and replace with corresponding outputs. More...
StkFrames & | tick (StkFrames &iFrames, StkFrames &oFrames, unsigned int iChannel=0, unsigned int oChannel=0)
| Take a channel of the `iFrames` object as inputs to the table and write outputs to the `oFrames` object. More...
Public Member Functions inherited from stk::Function
| Function (void)
| Class constructor.
StkFloat | lastOut (void) const
| Return the last computed output sample.
Public Member Functions inherited from stk::Stk
void | ignoreSampleRateChange (bool ignore=true)
| A function to enable/disable the automatic updating of class data when the STK sample rate changes. More...

## Additional Inherited Members
Static Public Member Functions inherited from stk::Stk
static StkFloat | sampleRate (void)
| Static method that returns the current STK sample rate.
static void | setSampleRate (StkFloat rate)
| Static method that sets the STK sample rate. More...
static void | clear_alertList ()
| Static method that frees memory from alertList_.
static std::string | rawwavePath (void)
| Static method that returns the current rawwave path.
static void | setRawwavePath (std::string path)
| Static method that sets the STK rawwave path.
static void | swap16 (unsigned char *ptr)
| Static method that byte-swaps a 16-bit data type.
static void | swap32 (unsigned char *ptr)
| Static method that byte-swaps a 32-bit data type.
static void | swap64 (unsigned char *ptr)
| Static method that byte-swaps a 64-bit data type.
static void | sleep (unsigned long milliseconds)
| Static cross-platform method to sleep for a number of milliseconds.
static bool | inRange (StkFloat value, StkFloat min, StkFloat max)
| Static method to check whether a value is within a specified range.
static void | handleError (const char *message, StkError::Type type)
| Static function for error reporting and handling using c-strings.
static void | handleError (std::string message, StkError::Type type)
| Static function for error reporting and handling using c++ strings.
static void | showWarnings (bool status)
| Toggle display of WARNING and STATUS messages.
static void | printErrors (bool status)
| Toggle display of error messages before throwing exceptions.
Static Public Attributes inherited from stk::Stk
static const StkFormat | STK_SINT8
static const StkFormat | STK_SINT16
static const StkFormat | STK_SINT24
static const StkFormat | STK_SINT32
static const StkFormat | STK_FLOAT32
static const StkFormat | STK_FLOAT64
Protected Member Functions inherited from stk::Stk
| Stk (void)
| Default constructor.
virtual | ~Stk (void)
| Class destructor.
virtual void | sampleRateChanged (StkFloat newRate, StkFloat oldRate)
| This function should be implemented in subclasses that depend on the sample rate.
void | addSampleRateAlert (Stk *ptr)
| Add class pointer to list for sample rate change notification.
void | removeSampleRateAlert (Stk *ptr)
| Remove class pointer from list for sample rate change notification.
void | handleError (StkError::Type type) const
| Internal function for error reporting that assumes message in `oStream_` variable.

## Detailed Description

STK jet table class.

This class implements a flue jet non-linear function, computed by a polynomial calculation. Contrary to the name, this is not a "table".

Consult Fletcher and Rossing, Karjalainen, Cook, and others for more information.

by Perry R. Cook and Gary P. Scavone, 1995–2017.

## Member Function Documentation

StkFrames & stk::JetTable::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0`
| ) |  |
| inline

Take a channel of the StkFrames object as inputs to the table and replace with corresponding outputs.

The StkFrames argument reference is returned. The `channel` argument must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

68 {
69 #if defined(_STK_DEBUG_)
70 if ( channel >= frames.channels() ) {
71 oStream_ << "JetTable::tick(): channel and StkFrames arguments are incompatible!";
72 handleError( StkError::FUNCTION_ARGUMENT );
73 }
74 #endif
75
76 StkFloat *samples = &frames[channel];
77 unsigned int hop = frames.channels();
78 for ( unsigned int i=0; i<frames.frames(); i++, samples += hop ) {
79 *samples = *samples * (*samples * *samples - 1.0);
80 if ( *samples > 1.0) *samples = 1.0;
81 if ( *samples < -1.0) *samples = -1.0;
82 }
83
84 lastFrame_[0] = *(samples-hop);
85 return frames;
86 }

StkFrames & stk::JetTable::tick | ( | StkFrames & | iFrames,
|  | StkFrames & | oFrames,
|  | unsigned int | iChannel = `0`,
|  | unsigned int | oChannel = `0`
| ) |  |
| inline

Take a channel of the `iFrames` object as inputs to the table and write outputs to the `oFrames` object.

The `iFrames` object reference is returned. Each channel argument must be less than the number of channels in the corresponding StkFrames argument (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

89 {
90 #if defined(_STK_DEBUG_)
91 if ( iChannel >= iFrames.channels() || oChannel >= oFrames.channels() ) {
92 oStream_ << "JetTable::tick(): channel and StkFrames arguments are incompatible!";
93 handleError( StkError::FUNCTION_ARGUMENT );
94 }
95 #endif
96
97 StkFloat *iSamples = &iFrames[iChannel];
98 StkFloat *oSamples = &oFrames[oChannel];
99 unsigned int iHop = iFrames.channels(), oHop = oFrames.channels();
100 for ( unsigned int i=0; i<iFrames.frames(); i++, iSamples += iHop, oSamples += oHop ) {
101 *oSamples = *oSamples * (*oSamples * *oSamples - 1.0);
102 if ( *oSamples > 1.0) *oSamples = 1.0;
103 if ( *oSamples < -1.0) *oSamples = -1.0;
104 }
105
106 lastFrame_[0] = *(oSamples-oHop);
107 return iFrames;
108 }

The documentation for this class was generated from the following file:

- JetTable.h

The Synthesis ToolKit in C++ (STK)
©1995--2017 Perry R. Cook and Gary P. Scavone. All Rights Reserved.